//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class LocalCoordinatesSite : VirtualSite {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal LocalCoordinatesSite(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.LocalCoordinatesSite_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(LocalCoordinatesSite obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~LocalCoordinatesSite() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_LocalCoordinatesSite(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public LocalCoordinatesSite(SWIGTYPE_p_std__vectorT_int_t particles, SWIGTYPE_p_std__vectorT_double_t originWeights, SWIGTYPE_p_std__vectorT_double_t xWeights, SWIGTYPE_p_std__vectorT_double_t yWeights, Vec3 localPosition) : this(OpenMMSwigPINVOKE.new_LocalCoordinatesSite__SWIG_0(SWIGTYPE_p_std__vectorT_int_t.getCPtr(particles), SWIGTYPE_p_std__vectorT_double_t.getCPtr(originWeights), SWIGTYPE_p_std__vectorT_double_t.getCPtr(xWeights), SWIGTYPE_p_std__vectorT_double_t.getCPtr(yWeights), Vec3.getCPtr(localPosition)), true) {
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public LocalCoordinatesSite(int particle1, int particle2, int particle3, Vec3 originWeights, Vec3 xWeights, Vec3 yWeights, Vec3 localPosition) : this(OpenMMSwigPINVOKE.new_LocalCoordinatesSite__SWIG_1(particle1, particle2, particle3, Vec3.getCPtr(originWeights), Vec3.getCPtr(xWeights), Vec3.getCPtr(yWeights), Vec3.getCPtr(localPosition)), true) {
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void getOriginWeights(SWIGTYPE_p_std__vectorT_double_t weights) {
    OpenMMSwigPINVOKE.LocalCoordinatesSite_getOriginWeights__SWIG_0(swigCPtr, SWIGTYPE_p_std__vectorT_double_t.getCPtr(weights));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public Vec3 getOriginWeights() {
    Vec3 ret = new Vec3(OpenMMSwigPINVOKE.LocalCoordinatesSite_getOriginWeights__SWIG_1(swigCPtr), true);
    return ret;
  }

  public void getXWeights(SWIGTYPE_p_std__vectorT_double_t weights) {
    OpenMMSwigPINVOKE.LocalCoordinatesSite_getXWeights__SWIG_0(swigCPtr, SWIGTYPE_p_std__vectorT_double_t.getCPtr(weights));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public Vec3 getXWeights() {
    Vec3 ret = new Vec3(OpenMMSwigPINVOKE.LocalCoordinatesSite_getXWeights__SWIG_1(swigCPtr), true);
    return ret;
  }

  public void getYWeights(SWIGTYPE_p_std__vectorT_double_t weights) {
    OpenMMSwigPINVOKE.LocalCoordinatesSite_getYWeights__SWIG_0(swigCPtr, SWIGTYPE_p_std__vectorT_double_t.getCPtr(weights));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public Vec3 getYWeights() {
    Vec3 ret = new Vec3(OpenMMSwigPINVOKE.LocalCoordinatesSite_getYWeights__SWIG_1(swigCPtr), true);
    return ret;
  }

  public Vec3 getLocalPosition() {
    Vec3 ret = new Vec3(OpenMMSwigPINVOKE.LocalCoordinatesSite_getLocalPosition(swigCPtr), false);
    return ret;
  }

}

}
